function AaoGtcLink() {
	var AAO_URL_PART = "http://localhost:";
	var lastAaoSend = '';
	var dloop;
	var lastString = "";
	var lastCount = 0;
	var lastBarCount = 0;
	var lastTabCount = 0;
	var isLvarsActive = false;
	var isWebActive = false;
	var activeTouchButtons = [];
	var activeBarButtons = [];
	var activeTabButtons = [];
	var activeWebButtons = [];
	var apiport = 0;

	function DataLoop () {
		apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number');
		if (apiport != 0) {
			let gtcIndex = 0;
			let wgtcs = document.getElementsByTagName("wtg3000-gtc");
			if (wgtcs && wgtcs.length > 0){
				let lurl = wgtcs[0].getAttribute("url");
				let iIdx = lurl.indexOf("Index=");
				if (iIdx < 0){
					clearInterval(this.dloop);
					return;
				}
				gtcIndex = parseInt(lurl.substr(iIdx + 6, 1));
				let reqindex = SimVar.GetSimVarValue('L:GTC_INDEX', 'Number') + 1;
				if (gtcIndex != reqindex){
					isLvarsActive = false;
				}else{
					if (!isLvarsActive){
						isLvarsActive = true;
						lastString = "";
					}
					ExportLVars();
				}
				let webgtcactive = SimVar.GetSimVarValue('L:GTC_WEB_ACTIVE_' + gtcIndex.toString(), 'Number');
				if (webgtcactive == 1){
					if (!isWebActive){
						isWebActive = true;
						lastAaoSend = '';
					}
				} else{
					isWebActive = false;
				}
			}
			if(!isLvarsActive && !isWebActive)
				return;
			if (isWebActive && gtcIndex > 0) ExportToWeb(gtcIndex);

			// buttonclick
			{
				var getrequestObj = {};
				getrequestObj.pullstringlvars = [];
				let tosend = { "var": "(L:AAO_GTC_BUTTON, String)", "value": ""};
				getrequestObj.pullstringlvars.push(tosend);
				tosend = { "var": "(L:AAO_GTC_BARBUTTON, String)", "value": ""};
				getrequestObj.pullstringlvars.push(tosend);
				tosend = { "var": "(L:AAO_GTC_TABBUTTON, String)", "value": ""};
				getrequestObj.pullstringlvars.push(tosend);
				tosend = { "var": "(L:AAO_GTC_WEBBUTTON_" + gtcIndex.toString() + ", String)", "value": ""};
				getrequestObj.pullstringlvars.push(tosend);
				var grelxhttp = new XMLHttpRequest();
				grelxhttp.addEventListener("load", aaoDataRequestListener);
				let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
				grelxhttp.open("POST", relurl);
				grelxhttp.send(JSON.stringify(getrequestObj));
			}
		}
	};
	
	function ExportLVars () {
		let requestObj = {};
		requestObj.setstringvars = [];
		requestObj.setvars = [];
		let currButtons = [];
		let currBarButtons = [];
		let currTabs = [];
		let currStr = "";
		let currCnt = 0;
		let currTabCnt = 0;
		let gmain = document.getElementsByClassName("gtc-main");
		let stacks = document.getElementsByClassName("gtc-view-stack");
		if (stacks){
			let checkHidden = false;
			if (gmain && gmain.length > 0 && gmain[0].className.indexOf("gtc-vertical") >= 0){
				checkHidden = true;
			} else{
				for (let i = 0; i < stacks.length; i++){
					if (stacks[i].className.indexOf("hidden") >= 0){
						checkHidden = true;
						break;
					}
				}
			}
			if (checkHidden)
			{
				for (let i = 0; i < stacks.length; i++){
					if (stacks[i].className.indexOf("hidden") < 0){
						let pageNum = 0;
						if (stacks[i].className.indexOf("gtc-mfd") > 0){
							pageNum = 1;
						} else{
							if (stacks[i].className.indexOf("gtc-navcom") > 0){
								pageNum = 2;
							}
						}
						let views = stacks[i].getElementsByClassName("gtc-view");
						if (views){
							for (let v = 0; v < views.length; v++){
								if (views[v].className.indexOf("hidden") < 0){
									let buttonIndex = 1;
									let btns = views[v].getElementsByClassName("touch-button");
									if (btns && btns.length > 0){
										currButtons = [];
										currCnt = 0;
										requestObj.setstringvars = [];
										requestObj.setvars = [];
										buttonIndex = 1;
										for (let b = 0; b < btns.length; b++) {
											let sval = "";
											let subval = "";
											let indval = 0;
											let enval = 1;
											if (btns[b].className.indexOf("touch-button-hidden") > 0)
												continue;
											if (btns[b].className.indexOf("touch-button-disabled") > 0)
												enval = 0;
											let flip = false;
											if (btns[b].className.indexOf("row-right") >= 0){
												let sdivs = btns[b].parentElement.children;
												for (let sdi = 0; sdi < sdivs.length; sdi++){
													if (sdivs[sdi].className.indexOf("row-left") >= 0 && sdivs[sdi].className.indexOf("touch-button") < 0){
														subval = sdivs[sdi].textContent.replace(/(\r\n|\n|\r)/gm, " ");
														flip = true;
														break;
													}
												}
											}
											if (btns[b].parentElement.className.indexOf("altitude-box") > 0){
												let slabs = btns[b].parentElement.getElementsByClassName("line-1");
												if (slabs && slabs.length > 0)
													sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
												slabs = btns[b].parentElement.getElementsByClassName("line-2");
												if (slabs && slabs.length > 0)
													subval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											}
											let slabs = btns[b].getElementsByClassName("touch-button-label");
											if (slabs && slabs.length > 0)
												sval = sval + slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[b].getElementsByClassName("leg-name-display");
											if (slabs && slabs.length > 0)
												sval = sval + slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[b].getElementsByClassName("numberunit-num");
											if (sval === "" && slabs && slabs.length > 0){
												sval = sval + slabs[0].textContent;
												slabs = btns[b].getElementsByClassName("numberunit-unit-big");
												if (slabs && slabs.length > 0)
													sval = sval + slabs[0].textContent;
												slabs = btns[b].getElementsByClassName("numberunit-unit-small");
												if (slabs && slabs.length > 0)
													sval = sval + slabs[0].textContent;
											}
											slabs = btns[b].getElementsByClassName("top-label");
											if (slabs && slabs.length > 0)
												sval = sval + slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[b].getElementsByClassName("bottom-label");
											if (slabs && slabs.length > 0)
												subval = subval + slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											if (btns[b].className.indexOf("touch-button-value") > 0){
												slabs = btns[b].getElementsByClassName("touch-button-value-value");
												if (slabs && slabs.length > 0){
													if (subval === ""){
														subval = slabs[0].textContent;
													} else{
														sval = slabs[0].textContent;
													}
												}
											}
											if (btns[b].className.indexOf("value-button") > 0){
												slabs = btns[b].children;
												for (let sdi = 0; sdi < slabs.length; sdi++){
													if (slabs[sdi].className.indexOf("button-label") >= 0){
														sval = slabs[sdi].textContent.replace(/(\r\n|\n|\r)/gm, " ");
													}
													if (slabs[sdi].className.indexOf("button-value") >= 0){
														subval = slabs[sdi].textContent.replace(/(\r\n|\n|\r)/gm, " ");
													}
												}
											}
											if (btns[b].className.indexOf("gtc-wpt-button") > 0){
												slabs = btns[b].getElementsByClassName("gtc-wpt-display-ident");
												if (slabs && slabs.length > 0){
													sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
												}
												slabs = btns[b].getElementsByClassName("gtc-wpt-display-name");
												if (slabs && slabs.length > 0){
													subval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
												}
											}
											if (sval === "" && (btns[b].className.indexOf("-dto") > 0 || btns[b].className.indexOf("direct-to") > 0)){
												sval = "Direct-To";
											}
											slabs = btns[b].getElementsByClassName("toggle-status-bar");
											if (slabs && slabs.length > 0){
												indval = 1;
												if (slabs[0].className.indexOf("toggle-status-bar-on") > 0)
													indval = 2;
											}
											slabs = btns[b].getElementsByClassName("active-freq");
											if (slabs && slabs.length > 0)
												sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[b].getElementsByClassName("stby-freq");
											if (slabs && slabs.length > 0)
												subval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[b].getElementsByClassName("dme-tune-mode");
											if (slabs && slabs.length > 0)
												subval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											currStr = currStr + "_" + sval + subval + indval.toString() + enval.toString();
											currCnt++;
											if (flip){
												let zw = subval;
												subval = sval;
												sval = zw;
											}
											let toset = { "var": "(L:G3000_GTC_SOFTKEY_" + buttonIndex.toString() + ", String)", "value": sval };
											requestObj.setstringvars.push(toset);
											toset = { "var": "(L:G3000_GTC_SOFTKEY_" + buttonIndex.toString() + "_1, String)", "value": subval };
											requestObj.setstringvars.push(toset);
											toset = { "var": "(L:G3000_GTC_SOFTKEY_" + buttonIndex.toString() + "_INDICATOR)", "value": indval };
											requestObj.setvars.push(toset);
											toset = { "var": "(L:G3000_GTC_SOFTKEY_" + buttonIndex.toString() + "_ENABLED)", "value": enval };
											requestObj.setvars.push(toset);
											currButtons.push(btns[b]);
											buttonIndex++;
										}
									}
									let inval = "";
									btns = views[v].getElementsByClassName("bg-img-touch-button");
									if (btns && btns.length > 0){
										for (let bi = 0; bi < btns.length; bi++) {
											if (btns[bi].className.indexOf("hidden") > 0)
												continue;
											let sval = "";
											let subval = "";
											let slabs = btns[bi].getElementsByClassName("bg-img-touch-button-label");
											if (slabs && slabs.length > 0)
												sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[bi].getElementsByClassName("com-label");
											if (slabs && slabs.length > 0)
												sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[bi].getElementsByClassName("triangle");
											if (slabs && slabs.length > 0){
												for (let si = 0; si < slabs.length; si++){
													if (slabs[si].className.indexOf("hidden") < 0)
														subval = slabs[si].textContent.replace(/(\r\n|\n|\r)/gm, " ");
												}
											}
											slabs = btns[bi].getElementsByClassName("frequency");
											if (slabs && slabs.length > 0)
												subval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[bi].getElementsByClassName("active-freq");
											if (slabs && slabs.length > 0)
												sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											slabs = btns[bi].getElementsByClassName("stby-freq");
											if (slabs && slabs.length > 0)
												subval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
											currStr = currStr + "_" + sval + subval;
											currCnt++;
											let toset = { "var": "(L:G3000_GTC_SOFTKEY_" + buttonIndex.toString() + ", String)", "value": sval };
											requestObj.setstringvars.push(toset);
											toset = { "var": "(L:G3000_GTC_SOFTKEY_" + buttonIndex.toString() + "_1, String)", "value": subval };
											requestObj.setstringvars.push(toset);
											toset = { "var": "(L:G3000_GTC_SOFTKEY_" + buttonIndex.toString() + "_INDICATOR)", "value": 0 };
											requestObj.setvars.push(toset);
											toset = { "var": "(L:G3000_GTC_SOFTKEY_" + buttonIndex.toString() + "_ENABLED)", "value": 1 };
											requestObj.setvars.push(toset);
											currButtons.push(btns[bi]);
											buttonIndex++;
										}
										let slabs = btns[0].parentElement.parentElement.parentElement.getElementsByClassName("cursor-input-slot-character");
										for (let bi = 0; bi < slabs.length; bi++) {
											inval = inval + slabs[bi].textContent;
										}
									}
									let slabs = views[v].getElementsByClassName("input-text");
									if (slabs){
										for (let bi = 0; bi < slabs.length; bi++) {
											inval = inval + slabs[bi].textContent;
										}
									}
									currStr = currStr + "_" + inval;
									let toset = { "var": "(L:G3000_GTC_INPUT, String)", "value": inval };
									requestObj.setstringvars.push(toset);
									btns = views[v].getElementsByClassName("gtc-tab");
									if (btns && btns.length > 0){
										for (let bi = 0; bi < btns.length; bi++) {
											if (btns[bi].className.indexOf("hidden") > 0)
												continue;
											let sval = btns[bi].innerText;
											let subval = "";
											currStr = currStr + "_" + sval + subval;
											currTabCnt++;
											let toset = { "var": "(L:G3000_GTC_TABKEY_" + currTabCnt.toString() + ", String)", "value": sval };
											requestObj.setstringvars.push(toset);
											currTabs.push(btns[bi]);
										}
									}
								}
							}
						}
						let toset = { "var": "(L:G3000_GTC_PAGE)", "value": pageNum };
						requestObj.setvars.push(toset);
					}
				}
			}
		}
		let currBarCnt = 0;
		let bbars = document.getElementsByClassName("button-bar");
		if (bbars && bbars.length > 0){
			for (let b = 1; b < 5; b++) {
				let sval = "";
				let enval = 1;
				let slotclass = "slot-" + b.toString();
				let btns = bbars[0].getElementsByClassName(slotclass);
				for (let sb = 0; sb < btns.length; sb++) {
					if (btns[sb].className.indexOf("touch-button-hidden") > 0){
						continue;
					}
					if (btns[sb].className.indexOf("touch-button-disabled") > 0)
						enval = 0;
					let slabs = btns[sb].getElementsByClassName("touch-button-label");
					if (slabs && slabs.length > 0)
						sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
					slabs = btns[sb].getElementsByClassName("label");
					if (slabs && slabs.length > 0)
						sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
					currBarCnt++;
					currBarButtons.push(btns[sb]);
				}
				currStr = currStr + "_" + sval + enval.toString();
				if (sval === "")
				{
					currBarButtons.push("");
					currBarCnt++;
				}
				let toset = { "var": "(L:G3000_GTC_BARKEY_" + b.toString() + ", String)", "value": sval };
				requestObj.setstringvars.push(toset);
				toset = { "var": "(L:G3000_GTC_BARKEY_" + b.toString() + "_ENABLED)", "value": enval };
				requestObj.setvars.push(toset);
				
			}
			{
				let sval1 = "";
				let enval1 = 1;
				let sval2 = "";
				let enval2 = 1;
				
				let slotclass = "slot-5";
				let btns = bbars[0].getElementsByClassName(slotclass);
				if (btns[0].className.indexOf("touch-button-hidden") < 0){
					if (btns[0].className.indexOf("touch-button-disabled") > 0)
						enval1 = 0;
					let slabs = btns[0].getElementsByClassName("touch-button-label");
					if (slabs && slabs.length > 0)
						sval1 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
					slabs = btns[0].getElementsByClassName("label");
					if (slabs && slabs.length > 0)
						sval1 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
					if (btns[1].className.indexOf("touch-button-disabled") > 0)
						enval2 = 0;
					slabs = btns[1].getElementsByClassName("touch-button-label");
					if (slabs && slabs.length > 0)
						sval2 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
					slabs = btns[1].getElementsByClassName("label");
					if (slabs && slabs.length > 0)
						sval2 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
					currBarButtons.push(btns[0]);
					currBarButtons.push(btns[1]);
					currBarCnt++;
					currBarCnt++;
				} else{
					if (btns[2].className.indexOf("touch-button-hidden") < 0){
						if (btns[2].className.indexOf("touch-button-disabled") > 0)
							enval1 = 0;
						let slabs = btns[2].getElementsByClassName("touch-button-label");
						if (slabs && slabs.length > 0)
							sval1 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
						slabs = btns[2].getElementsByClassName("label");
						if (slabs && slabs.length > 0)
							sval1 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
						if (btns[3].className.indexOf("touch-button-disabled") > 0)
							enval2 = 0;
						slabs = btns[3].getElementsByClassName("touch-button-label");
						if (slabs && slabs.length > 0)
							sval2 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
						slabs = btns[3].getElementsByClassName("label");
						if (slabs && slabs.length > 0)
							sval2 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
						currBarButtons.push(btns[2]);
						currBarButtons.push(btns[3]);
						currBarCnt++;
						currBarCnt++;
					} else{
						
						if (btns[4].className.indexOf("touch-button-hidden") < 0){
							
							if (btns[4].className.indexOf("touch-button-disabled") > 0)
								enval1 = 0;
							let slabs = btns[4].getElementsByClassName("touch-button-label");
							if (slabs && slabs.length > 0)
								sval1 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
							slabs = btns[4].getElementsByClassName("label");
							if (slabs && slabs.length > 0)
								sval1 = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
							currBarButtons.push(btns[4]);
							currBarCnt++;
						}
					}
				}
				currStr = currStr + "_" + sval1 + enval1.toString() + sval2 + enval2.toString();
				let toset = { "var": "(L:G3000_GTC_BARKEY_5, String)", "value": sval1 };
				requestObj.setstringvars.push(toset);
				toset = { "var": "(L:G3000_GTC_BARKEY_5_ENABLED)", "value": enval1 };
				requestObj.setvars.push(toset);
				toset = { "var": "(L:G3000_GTC_BARKEY_6, String)", "value": sval2 };
				requestObj.setstringvars.push(toset);
				toset = { "var": "(L:G3000_GTC_BARKEY_6_ENABLED)", "value": enval2 };
				requestObj.setvars.push(toset);
			}
		}

		for (let j = currCnt; j < lastCount; j++){
			currStr = currStr + "_" + "";
			let toset = { "var": "(L:G3000_GTC_SOFTKEY_" + (j + 1).toString() + ", String)", "value": "" };
			requestObj.setstringvars.push(toset);
			toset = { "var": "(L:G3000_GTC_SOFTKEY_" + (j + 1).toString() + "_1, String)", "value": "" };
			requestObj.setstringvars.push(toset);
			toset = { "var": "(L:G3000_GTC_SOFTKEY_" + (j + 1).toString() + "_INDICATOR)", "value": 0 };
			requestObj.setvars.push(toset);
			toset = { "var": "(L:G3000_GTC_SOFTKEY_" + (j + 1).toString() + "_ENABLED)", "value": 0 };
			requestObj.setvars.push(toset);
		}
		lastCount = currCnt;
		for (let j = currBarCnt; j < lastBarCount; j++){
			currStr = currStr + "_" + "";
			let toset = { "var": "(L:G3000_GTC_BARKEY_" + (j + 1).toString() + ", String)", "value": "" };
			requestObj.setstringvars.push(toset);
			toset = { "var": "(L:G3000_GTC_BARKEY_" + (j + 1).toString() + "_ENABLED)", "value": 0 };
			requestObj.setvars.push(toset);
		}
		lastBarCount = currBarCnt;
		for (let j = currTabCnt; j < lastTabCount; j++){
			currStr = currStr + "_" + "";
			let toset = { "var": "(L:G3000_GTC_TABKEY_" + (j + 1).toString() + ", String)", "value": "" };
			requestObj.setstringvars.push(toset);
		}
		lastTabCount = currTabCnt;
		if (currStr !== lastString){
			activeTouchButtons = [];
			for (let cb = 0; cb < currButtons.length; cb++)
				activeTouchButtons.push(currButtons[cb]);
			activeBarButtons = [];
			for (let cb = 0; cb < currBarButtons.length; cb++)
				activeBarButtons.push(currBarButtons[cb]);
			for (let cb = 0; cb < currTabs.length; cb++)
				activeTabButtons.push(currTabs[cb]);
			lastString = currStr;
			let toset = { "var": "(L:G3000_GTC_NUM_BUTTONS)", "value": currButtons.length };
			requestObj.setvars.push(toset);
			let relxhttp = new XMLHttpRequest();
			let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
			relxhttp.open("POST", relurl);
			relxhttp.send(JSON.stringify(requestObj));
		}
	};
	
	function ExportToWeb (gtcindex) {
		let forceUpdate = SimVar.GetSimVarValue('L:AAO_FMC_HTML_INIT', 'Number');
		let mf = document.getElementById("Mainframe");
		if (mf){
			let screen = mf.innerHTML;
			if (forceUpdate == 1 || lastAaoSend !== screen){
				lastAaoSend = screen;
				let tosend = { "fname": "wtg3000gtc/gtc" + gtcindex + ".html", "part": 0, "of": 1, "isvirtual": "true", "base64": window.btoa(unescape(encodeURIComponent(screen))) };
				let requestObj = {};
				requestObj.files = [];
				requestObj.files.push(tosend);
				let relxhttp = new XMLHttpRequest();
				let relurl = encodeURI(AAO_URL_PART + (apiport + (gtcindex % 2)).toString() + "/webapi/");
				relxhttp.open("POST", relurl);
				relxhttp.send(JSON.stringify(requestObj));
				SimVar.SetSimVarValue("L:AAO_FMC_HTML_INIT", "Number", 0);
			}
		}
	};
	
	function aaoDataRequestListener (){
		let commObj = JSON.parse(this.responseText);
		let eleStr = commObj.pullstringlvars[0].value;
		if (eleStr && eleStr.length > 0){
			var allIds = eleStr.split(',');
			for (let e = 0; e < allIds.length; e++){
				var elefire = null;
				var eleid = allIds[e];
				if (eleid && eleid.length > 0){
					elefire = activeTouchButtons[parseInt(eleid) - 1];
				}
				if (elefire){
					var ev = new MouseEvent('mousedown', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
					ev = new MouseEvent('mouseup', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
				}
			}
		}
		eleStr = commObj.pullstringlvars[1].value;
		if (eleStr && eleStr.length > 0){
			var allIds = eleStr.split(',');
			for (let e = 0; e < allIds.length; e++){
				var elefire = null;
				var eleid = allIds[e];
				if (eleid && eleid.length > 0){
					elefire = activeBarButtons[parseInt(eleid) - 1];
				}
				if (elefire){
					var ev = new MouseEvent('mousedown', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
					ev = new MouseEvent('mouseup', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
				}
			}
		}
		eleStr = commObj.pullstringlvars[2].value;
		if (eleStr && eleStr.length > 0){
			var allIds = eleStr.split(',');
			for (let e = 0; e < allIds.length; e++){
				var elefire = null;
				var eleid = allIds[e];
				if (eleid && eleid.length > 0){
					elefire = activeTabButtons[parseInt(eleid) - 1];
				}
				if (elefire){
					var ev = new MouseEvent('mousedown', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
					ev = new MouseEvent('mouseup', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
				}
			}
		}
		eleStr = commObj.pullstringlvars[3].value;
		if (eleStr && eleStr.length > 0){
			activeWebButtons = [];
			let qss = document.querySelectorAll(".touch-button");
			for (let i = 0; i < qss.length; i++)
				activeWebButtons.push(qss[i]);
			qss = document.querySelectorAll(".bg-img-touch-button");
			for (let i = 0; i < qss.length; i++)
				activeWebButtons.push(qss[i]);
			qss = document.querySelectorAll(".gtc-tab");
			for (let i = 0; i < qss.length; i++)
				activeWebButtons.push(qss[i]);
			var allIds = eleStr.split(',');
			for (let e = 0; e < allIds.length; e++){
				var elefire = null;
				var eleid = allIds[e];
				if (eleid && eleid.length > 0){
					elefire = activeWebButtons[parseInt(eleid)];
				}
				if (elefire){
					var ev = new MouseEvent('mousedown', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
					ev = new MouseEvent('mouseup', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
				}
			}
		}
	};

	this.startup = function () {
		
		dloop = setInterval(DataLoop, 75);
	};
	
	this.shutdown = function () {
		clearInterval(dloop);
	};
};

var aaogtcmodule = new AaoGtcLink();
aaogtcmodule.startup();


